diff --git a/src/backend/access/heap/heapam.c b/src/backend/access/heap/heapam.c
index 5a9d6c46da..1467091d10 100644
--- a/src/backend/access/heap/heapam.c
+++ b/src/backend/access/heap/heapam.c
@@ -5658,8 +5658,8 @@ l5:
 				 * TransactionIdIsInProgress() should have returned false.  We
 				 * assume it's no longer locked in this case.
 				 */
-				elog(WARNING, "LOCK_ONLY found for Xid in progress %llu",
-					 (unsigned long long) xmax);
+				elog(WARNING, "LOCK_ONLY found for Xid in progress %" PRIu64,
+					 xmax);
 				old_infomask |= HEAP_XMAX_INVALID;
 				old_infomask &= ~HEAP_XMAX_LOCK_ONLY;
 				goto l5;
@@ -6916,9 +6916,8 @@ FreezeMultiXactId(MultiXactId multi, uint16 t_infomask,
 	else if (MultiXactIdPrecedes(multi, cutoffs->relminmxid))
 		ereport(ERROR,
 				(errcode(ERRCODE_DATA_CORRUPTED),
-				 errmsg_internal("found multixact %llu from before relminmxid %llu",
-								 (unsigned long long) multi,
-								 (unsigned long long) cutoffs->relminmxid)));
+				 errmsg_internal("found multixact %" PRIu64 " from before relminmxid %" PRIu64,
+								 multi, cutoffs->relminmxid)));
 	else if (MultiXactIdIsValid(multi) &&
 			 (t_infomask & HEAP_XMAX_INVALID))
 	{
@@ -6941,9 +6940,8 @@ FreezeMultiXactId(MultiXactId multi, uint16 t_infomask,
 								 HEAP_XMAX_IS_LOCKED_ONLY(t_infomask)))
 			ereport(ERROR,
 					(errcode(ERRCODE_DATA_CORRUPTED),
-					 errmsg_internal("multixact %llu from before cutoff %llu found to be still running",
-									 (unsigned long long) multi,
-									 (unsigned long long) cutoffs->OldestMxact)));
+					 errmsg_internal("multixact %" PRIu64 " from before cutoff %" PRIu64 " found to be still running",
+									 multi, cutoffs->OldestMxact)));
 
 		if (HEAP_XMAX_IS_LOCKED_ONLY(t_infomask))
 		{
@@ -6957,10 +6955,9 @@ FreezeMultiXactId(MultiXactId multi, uint16 t_infomask,
 		if (TransactionIdPrecedes(update_xact, cutoffs->relfrozenxid))
 			ereport(ERROR,
 					(errcode(ERRCODE_DATA_CORRUPTED),
-					 errmsg_internal("multixact %llu contains update XID %llu from before relfrozenxid %llu",
-									 (unsigned long long) multi,
-									 (unsigned long long) update_xact,
-									 (unsigned long long) cutoffs->relfrozenxid)));
+					 errmsg_internal("multixact %" PRIu64 " contains update XID %" PRIu64 " from before relfrozenxid %" PRIu64,
+									 multi, update_xact,
+									 cutoffs->relfrozenxid)));
 		else if (TransactionIdPrecedes(update_xact, cutoffs->OldestXmin))
 		{
 			/*
@@ -6971,10 +6968,9 @@ FreezeMultiXactId(MultiXactId multi, uint16 t_infomask,
 			if (!TransactionIdDidAbort(update_xact))
 				ereport(ERROR,
 						(errcode(ERRCODE_DATA_CORRUPTED),
-						 errmsg_internal("multixact %llu contains non-aborted update XID %llu from before removable cutoff %llu",
-										 (unsigned long long) multi,
-										 (unsigned long long) update_xact,
-										 (unsigned long long) cutoffs->OldestXmin)));
+						 errmsg_internal("multixact %" PRIu64 " contains non-aborted update XID %" PRIu64 " from before removable cutoff %" PRIu64,
+										 multi, update_xact,
+										 cutoffs->OldestXmin)));
 			*flags |= FRM_INVALIDATE_XMAX;
 			pagefrz->freeze_required = true;
 			return InvalidTransactionId;
@@ -7093,10 +7089,8 @@ FreezeMultiXactId(MultiXactId multi, uint16 t_infomask,
 				if (TransactionIdPrecedes(xid, cutoffs->OldestXmin))
 					ereport(ERROR,
 							(errcode(ERRCODE_DATA_CORRUPTED),
-							 errmsg_internal("multixact %llu contains running locker XID %llu from before removable cutoff %llu",
-											 (unsigned long long) multi,
-											 (unsigned long long) xid,
-											 (unsigned long long) cutoffs->OldestXmin)));
+							 errmsg_internal("multixact %" PRIu64 " contains running locker XID %" PRIu64 " from before removable cutoff %" PRIu64,
+											 multi, xid, cutoffs->OldestXmin)));
 				newmembers[nnewmembers++] = members[i];
 				has_lockers = true;
 			}
@@ -7118,11 +7112,10 @@ FreezeMultiXactId(MultiXactId multi, uint16 t_infomask,
 		if (TransactionIdIsValid(update_xid))
 			ereport(ERROR,
 					(errcode(ERRCODE_DATA_CORRUPTED),
-					 errmsg_internal("multixact %llu has two or more updating members",
-									 (unsigned long long) multi),
-					 errdetail_internal("First updater XID=%llu second updater XID=%llu.",
-										(unsigned long long) update_xid,
-										(unsigned long long) xid)));
+					 errmsg_internal("multixact %" PRIu64 " has two or more updating members",
+									 multi),
+					 errdetail_internal("First updater XID=%" PRIu64 " second updater XID=%" PRIu64 ".",
+										update_xid, xid)));
 
 		/*
 		 * As with all tuple visibility routines, it's critical to test
@@ -7158,10 +7151,8 @@ FreezeMultiXactId(MultiXactId multi, uint16 t_infomask,
 		if (TransactionIdPrecedes(xid, cutoffs->OldestXmin))
 			ereport(ERROR,
 					(errcode(ERRCODE_DATA_CORRUPTED),
-					 errmsg_internal("multixact %llu contains committed update XID %llu from before removable cutoff %llu",
-									 (unsigned long long) multi,
-									 (unsigned long long) xid,
-									 (unsigned long long) cutoffs->OldestXmin)));
+					 errmsg_internal("multixact %" PRIu64 " contains committed update XID %" PRIu64 " from before removable cutoff %" PRIu64,
+									 multi, xid, cutoffs->OldestXmin)));
 		newmembers[nnewmembers++] = members[i];
 	}
 
@@ -7285,9 +7276,8 @@ heap_prepare_freeze_tuple(HeapTuple htup,
 		if (TransactionIdPrecedes(xid, cutoffs->relfrozenxid))
 			ereport(ERROR,
 					(errcode(ERRCODE_DATA_CORRUPTED),
-					 errmsg_internal("found xmin %llu from before relfrozenxid %llu",
-									 (unsigned long long) xid,
-									 (unsigned long long) cutoffs->relfrozenxid)));
+					 errmsg_internal("found xmin %" PRIu64 " from before relfrozenxid %" PRIu64,
+									 xid, cutoffs->relfrozenxid)));
 
 		/* Will set freeze_xmin flags in freeze plan below */
 		freeze_xmin = TransactionIdPrecedes(xid, cutoffs->OldestXmin);
@@ -7434,9 +7424,8 @@ heap_prepare_freeze_tuple(HeapTuple htup,
 		if (TransactionIdPrecedes(xid, cutoffs->relfrozenxid))
 			ereport(ERROR,
 					(errcode(ERRCODE_DATA_CORRUPTED),
-					 errmsg_internal("found xmax %llu from before relfrozenxid %llu",
-									 (unsigned long long) xid,
-									 (unsigned long long) cutoffs->relfrozenxid)));
+					 errmsg_internal("found xmax %" PRIu64 " from before relfrozenxid %" PRIu64,
+									 xid, cutoffs->relfrozenxid)));
 
 		/* Will set freeze_xmax flags in freeze plan below */
 		freeze_xmax = TransactionIdPrecedes(xid, cutoffs->OldestXmin);
@@ -7458,8 +7447,8 @@ heap_prepare_freeze_tuple(HeapTuple htup,
 	else
 		ereport(ERROR,
 				(errcode(ERRCODE_DATA_CORRUPTED),
-				 errmsg_internal("found raw xmax %llu (infomask 0x%04x) not invalid and not multi",
-								 (unsigned long long) xid, tuple->t_infomask)));
+				 errmsg_internal("found raw xmax %" PRIu64 " (infomask 0x%04x) not invalid and not multi",
+								 xid, tuple->t_infomask)));
 
 	if (freeze_xmin)
 	{
@@ -7562,8 +7551,8 @@ heap_pre_freeze_checks(Relation rel, Buffer buffer,
 			if (unlikely(!TransactionIdDidCommit(xmin)))
 				ereport(ERROR,
 						(errcode(ERRCODE_DATA_CORRUPTED),
-						 errmsg_internal("uncommitted xmin %llu needs to be frozen",
-										 (unsigned long long) xmin)));
+						 errmsg_internal("uncommitted xmin %" PRIu64 " needs to be frozen",
+										 xmin)));
 		}
 		if (frz->checkflags & HEAP_FREEZE_CHECK_XMAX_ABORTED)
 		{
@@ -7573,8 +7562,8 @@ heap_pre_freeze_checks(Relation rel, Buffer buffer,
 			if (unlikely(!TransactionIdDidAbort(xmax)))
 				ereport(ERROR,
 						(errcode(ERRCODE_DATA_CORRUPTED),
-						 errmsg_internal("cannot freeze non-aborted xmax %llu",
-										 (unsigned long long) xmax)));
+						 errmsg_internal("cannot freeze non-aborted xmax %" PRIu64,
+										 xmax)));
 		}
 	}
 }
@@ -9929,17 +9918,14 @@ heap_page_check_delta(Buffer buffer,
 						  buf->tag.forkNum);
 
 	if (freeDelta == NULL)
-		elog(FATAL, "Fatal xid base calculation error: xid = %llu, base = %llu, min = %u, max = %u, delta = %lld (rel=%s, blockNum=%u)",
-					(unsigned long long) xid, (unsigned long long) base,
-					min, max,
-					(long long) delta,
-					path.str, buf->tag.blockNum);
-
-	elog(FATAL, "Fatal xid base calculation error: xid = %llu, base = %llu, min = %u, max = %u, freeDelta = %lld, requiredDelta = %lld, delta = %lld (rel=%s, blockNum=%u)",
-				(unsigned long long) xid, (unsigned long long) base,
-				min, max,
-				(long long) *freeDelta, (long long) *requiredDelta,
-				(long long) delta,
+		elog(FATAL, "fatal xid base calculation error: xid = %" PRIu64 ", base = %" PRIu64 ", "
+					"min = %u, max = %u, delta = %" PRId64 " (rel=%s, blockNum=%u)",
+					xid, base,min, max, delta, path.str, buf->tag.blockNum);
+
+	elog(FATAL, "fatal xid base calculation error: xid = %" PRIu64 ", base = %" PRIu64 ", "
+				"min = %u, max = %u, freeDelta = %" PRId64 ", requiredDelta = %" PRId64 ", "
+				"delta = %" PRId64 " (rel=%s, blockNum=%u)",
+				xid, base, min, max, *freeDelta, *requiredDelta, delta,
 				path.str, buf->tag.blockNum);
 }
 
diff --git a/src/backend/access/heap/heapam_handler.c b/src/backend/access/heap/heapam_handler.c
index 3aee8db6b3..da0af260ef 100644
--- a/src/backend/access/heap/heapam_handler.c
+++ b/src/backend/access/heap/heapam_handler.c
@@ -438,8 +438,8 @@ tuple_lock_retry:
 					if (TransactionIdIsValid(SnapshotDirty.xmin))
 						ereport(ERROR,
 								(errcode(ERRCODE_DATA_CORRUPTED),
-								 errmsg_internal("t_xmin %llu is uncommitted in tuple (%u,%u) to be updated in table \"%s\"",
-												 (unsigned long long) SnapshotDirty.xmin,
+								 errmsg_internal("t_xmin %" PRIu64 " is uncommitted in tuple (%u,%u) to be updated in table \"%s\"",
+												 SnapshotDirty.xmin,
 												 ItemPointerGetBlockNumber(&tuple->t_self),
 												 ItemPointerGetOffsetNumber(&tuple->t_self),
 												 RelationGetRelationName(relation))));
diff --git a/src/backend/access/heap/vacuumlazy.c b/src/backend/access/heap/vacuumlazy.c
index 4517967c43..877ad2b059 100644
--- a/src/backend/access/heap/vacuumlazy.c
+++ b/src/backend/access/heap/vacuumlazy.c
@@ -1031,26 +1031,26 @@ heap_vacuum_rel(Relation rel, const VacuumParams params,
 			diff = (int64) (ReadNextTransactionId() -
 							vacrel->cutoffs.OldestXmin);
 			appendStringInfo(&buf,
-							 _("removable cutoff: %llu, which was %lld XIDs old when operation ended\n"),
-							 (unsigned long long) vacrel->cutoffs.OldestXmin,
-							 (long long) diff);
+							 _("removable cutoff: %" PRIu64 ", which was %" PRId64 " XIDs old when operation ended\n"),
+							 vacrel->cutoffs.OldestXmin,
+							 diff);
 			if (frozenxid_updated)
 			{
 				diff = (int64) (vacrel->NewRelfrozenXid -
 								vacrel->cutoffs.relfrozenxid);
 				appendStringInfo(&buf,
-								 _("new relfrozenxid: %llu, which is %lld XIDs ahead of previous value\n"),
-								 (unsigned long long) vacrel->NewRelfrozenXid,
-								 (long long) diff);
+								 _("new relfrozenxid: %" PRIu64 ", which is %" PRId64 " XIDs ahead of previous value\n"),
+								 vacrel->NewRelfrozenXid,
+								 diff);
 			}
 			if (minmulti_updated)
 			{
 				diff = (int64) (vacrel->NewRelminMxid -
 								vacrel->cutoffs.relminmxid);
 				appendStringInfo(&buf,
-								 _("new relminmxid: %llu, which is %lld MXIDs ahead of previous value\n"),
-								 (unsigned long long) vacrel->NewRelminMxid,
-								 (long long) diff);
+								 _("new relminmxid: %" PRIu64 ", which is %" PRId64 " MXIDs ahead of previous value\n"),
+								 vacrel->NewRelminMxid,
+								 diff);
 			}
 			appendStringInfo(&buf, _("frozen: %u pages from table (%.2f%% of total) had %" PRId64 " tuples frozen\n"),
 							 vacrel->new_frozen_tuple_pages,
diff --git a/src/backend/access/rmgrdesc/clogdesc.c b/src/backend/access/rmgrdesc/clogdesc.c
index 6fc7b1a9a8..7e8c6e67ad 100644
--- a/src/backend/access/rmgrdesc/clogdesc.c
+++ b/src/backend/access/rmgrdesc/clogdesc.c
@@ -35,8 +35,8 @@ clog_desc(StringInfo buf, XLogReaderState *record)
 		xl_clog_truncate xlrec;
 
 		memcpy(&xlrec, rec, sizeof(xl_clog_truncate));
-		appendStringInfo(buf, "page %" PRId64 "; oldestXact %llu",
-						 xlrec.pageno, (unsigned long long) xlrec.oldestXact);
+		appendStringInfo(buf, "page %" PRId64 "; oldestXact %" PRIu64,
+						 xlrec.pageno, xlrec.oldestXact);
 	}
 }
 
diff --git a/src/backend/access/rmgrdesc/committsdesc.c b/src/backend/access/rmgrdesc/committsdesc.c
index 514aaefa44..265c5fda37 100644
--- a/src/backend/access/rmgrdesc/committsdesc.c
+++ b/src/backend/access/rmgrdesc/committsdesc.c
@@ -34,8 +34,8 @@ commit_ts_desc(StringInfo buf, XLogReaderState *record)
 	{
 		xl_commit_ts_truncate *trunc = (xl_commit_ts_truncate *) rec;
 
-		appendStringInfo(buf, "pageno %" PRId64 ", oldestXid %llu",
-						 trunc->pageno, (unsigned long long) trunc->oldestXid);
+		appendStringInfo(buf, "pageno %" PRId64 ", oldestXid %" PRIu64,
+						 trunc->pageno, trunc->oldestXid);
 	}
 }
 
diff --git a/src/backend/access/rmgrdesc/gistdesc.c b/src/backend/access/rmgrdesc/gistdesc.c
index a40cf333b2..3ddf1929c0 100644
--- a/src/backend/access/rmgrdesc/gistdesc.c
+++ b/src/backend/access/rmgrdesc/gistdesc.c
@@ -25,18 +25,18 @@ out_gistxlogPageUpdate(StringInfo buf, gistxlogPageUpdate *xlrec)
 static void
 out_gistxlogPageReuse(StringInfo buf, gistxlogPageReuse *xlrec)
 {
-	appendStringInfo(buf, "rel %u/%u/%u; blk %u; snapshotConflictHorizon %llu, isCatalogRel %c",
+	appendStringInfo(buf, "rel %u/%u/%u; blk %u; snapshotConflictHorizon %" PRIu64 ", isCatalogRel %c",
 					 xlrec->locator.spcOid, xlrec->locator.dbOid,
 					 xlrec->locator.relNumber, xlrec->block,
-					 (unsigned long long) XidFromFullTransactionId(xlrec->snapshotConflictHorizon),
+					 XidFromFullTransactionId(xlrec->snapshotConflictHorizon),
 					 xlrec->isCatalogRel ? 'T' : 'F');
 }
 
 static void
 out_gistxlogDelete(StringInfo buf, gistxlogDelete *xlrec)
 {
-	appendStringInfo(buf, "delete: snapshotConflictHorizon %llu, nitems: %u, isCatalogRel %c",
-					 (unsigned long long) xlrec->snapshotConflictHorizon,
+	appendStringInfo(buf, "delete: snapshotConflictHorizon %" PRIu64 ", nitems: %u, isCatalogRel %c",
+					 xlrec->snapshotConflictHorizon,
 					 xlrec->ntodelete, xlrec->isCatalogRel ? 'T' : 'F');
 }
 
@@ -50,8 +50,8 @@ out_gistxlogPageSplit(StringInfo buf, gistxlogPageSplit *xlrec)
 static void
 out_gistxlogPageDelete(StringInfo buf, gistxlogPageDelete *xlrec)
 {
-	appendStringInfo(buf, "deleteXid %llu; downlink %u",
-					 (unsigned long long) XidFromFullTransactionId(xlrec->deleteXid),
+	appendStringInfo(buf, "deleteXid %" PRIu64 "; downlink %u",
+					 XidFromFullTransactionId(xlrec->deleteXid),
 					 xlrec->downlinkOffset);
 }
 
diff --git a/src/backend/access/rmgrdesc/hashdesc.c b/src/backend/access/rmgrdesc/hashdesc.c
index b33769a2e4..7a42458537 100644
--- a/src/backend/access/rmgrdesc/hashdesc.c
+++ b/src/backend/access/rmgrdesc/hashdesc.c
@@ -113,9 +113,9 @@ hash_desc(StringInfo buf, XLogReaderState *record)
 			{
 				xl_hash_vacuum_one_page *xlrec = (xl_hash_vacuum_one_page *) rec;
 
-				appendStringInfo(buf, "ntuples %d, snapshotConflictHorizon %llu, isCatalogRel %c",
+				appendStringInfo(buf, "ntuples %d, snapshotConflictHorizon %" PRIu64 ", isCatalogRel %c",
 								 xlrec->ntuples,
-								 (unsigned long long) xlrec->snapshotConflictHorizon,
+								 xlrec->snapshotConflictHorizon,
 								 xlrec->isCatalogRel ? 'T' : 'F');
 				break;
 			}
diff --git a/src/backend/access/rmgrdesc/heapdesc.c b/src/backend/access/rmgrdesc/heapdesc.c
index b79cd85b5e..5976c82280 100644
--- a/src/backend/access/rmgrdesc/heapdesc.c
+++ b/src/backend/access/rmgrdesc/heapdesc.c
@@ -78,8 +78,8 @@ plan_elem_desc(StringInfo buf, void *plan, void *data)
 	xlhp_freeze_plan *new_plan = (xlhp_freeze_plan *) plan;
 	OffsetNumber **offsets = data;
 
-	appendStringInfo(buf, "{ xmax: %llu, infomask: %u, infomask2: %u, ntuples: %u",
-					 (unsigned long long) new_plan->xmax,
+	appendStringInfo(buf, "{ xmax: %" PRIu64 ", infomask: %u, infomask2: %u, ntuples: %u",
+					 new_plan->xmax,
 					 new_plan->t_infomask, new_plan->t_infomask2,
 					 new_plan->ntuples);
 
@@ -199,8 +199,8 @@ heap_desc(StringInfo buf, XLogReaderState *record)
 	{
 		xl_heap_delete *xlrec = (xl_heap_delete *) rec;
 
-		appendStringInfo(buf, "xmax: %llu, off: %u, ",
-						 (unsigned long long) xlrec->xmax, xlrec->offnum);
+		appendStringInfo(buf, "xmax: %" PRIu64 ", off: %u, ",
+						 xlrec->xmax, xlrec->offnum);
 		infobits_desc(buf, xlrec->infobits_set, "infobits");
 		appendStringInfo(buf, ", flags: 0x%02X", xlrec->flags);
 	}
@@ -208,26 +208,21 @@ heap_desc(StringInfo buf, XLogReaderState *record)
 	{
 		xl_heap_update *xlrec = (xl_heap_update *) rec;
 
-		appendStringInfo(buf, "old_xmax: %llu, old_off: %u, ",
-						 (unsigned long long) xlrec->old_xmax,
-						 xlrec->old_offnum);
+		appendStringInfo(buf, "old_xmax: %" PRIu64 ", old_off: %u, ",
+						 xlrec->old_xmax, xlrec->old_offnum);
 		infobits_desc(buf, xlrec->old_infobits_set, "old_infobits");
-		appendStringInfo(buf, ", flags: 0x%02X, new_xmax: %llu, new_off: %u",
-						 xlrec->flags,
-						 (unsigned long long) xlrec->new_xmax,
-						 xlrec->new_offnum);
+		appendStringInfo(buf, ", flags: 0x%02X, new_xmax: %" PRIu64 ", new_off: %u",
+						 xlrec->flags, xlrec->new_xmax, xlrec->new_offnum);
 	}
 	else if (info == XLOG_HEAP_HOT_UPDATE)
 	{
 		xl_heap_update *xlrec = (xl_heap_update *) rec;
 
-		appendStringInfo(buf, "old_xmax: %llu, old_off: %u, ",
-						 (unsigned long long) xlrec->old_xmax,
-						 xlrec->old_offnum);
+		appendStringInfo(buf, "old_xmax: %" PRIu64 ", old_off: %u, ",
+						 xlrec->old_xmax, xlrec->old_offnum);
 		infobits_desc(buf, xlrec->old_infobits_set, "old_infobits");
-		appendStringInfo(buf, ", flags: 0x%02X, new_xmax: %llu, new_off: %u",
-						 xlrec->flags, (unsigned long long) xlrec->new_xmax,
-						 xlrec->new_offnum);
+		appendStringInfo(buf, ", flags: 0x%02X, new_xmax: %" PRIu64 ", new_off: %u",
+						 xlrec->flags, xlrec->new_xmax, xlrec->new_offnum);
 	}
 	else if (info == XLOG_HEAP_TRUNCATE)
 	{
@@ -249,8 +244,8 @@ heap_desc(StringInfo buf, XLogReaderState *record)
 	{
 		xl_heap_lock *xlrec = (xl_heap_lock *) rec;
 
-		appendStringInfo(buf, "xmax: %llu, off: %u, ",
-						 (unsigned long long) xlrec->xmax, xlrec->offnum);
+		appendStringInfo(buf, "xmax: %" PRIu64 ", off: %u, ",
+						 xlrec->xmax, xlrec->offnum);
 		infobits_desc(buf, xlrec->infobits_set, "infobits");
 		appendStringInfo(buf, ", flags: 0x%02X", xlrec->flags);
 	}
@@ -284,8 +279,8 @@ heap2_desc(StringInfo buf, XLogReaderState *record)
 
 			memcpy(&conflict_xid, rec + SizeOfHeapPrune, sizeof(TransactionId));
 
-			appendStringInfo(buf, "snapshotConflictHorizon: %llu",
-							 (unsigned long long) conflict_xid);
+			appendStringInfo(buf, "snapshotConflictHorizon: %" PRIu64,
+							 conflict_xid);
 		}
 
 		appendStringInfo(buf, ", isCatalogRel: %c",
@@ -348,9 +343,8 @@ heap2_desc(StringInfo buf, XLogReaderState *record)
 	{
 		xl_heap_visible *xlrec = (xl_heap_visible *) rec;
 
-		appendStringInfo(buf, "snapshotConflictHorizon: %llu, flags: 0x%02X",
-						 (unsigned long long) xlrec->snapshotConflictHorizon,
-						 xlrec->flags);
+		appendStringInfo(buf, "snapshotConflictHorizon: %" PRIu64 ", flags: 0x%02X",
+						 xlrec->snapshotConflictHorizon, xlrec->flags);
 	}
 	else if (info == XLOG_HEAP2_MULTI_INSERT)
 	{
@@ -371,8 +365,8 @@ heap2_desc(StringInfo buf, XLogReaderState *record)
 	{
 		xl_heap_lock_updated *xlrec = (xl_heap_lock_updated *) rec;
 
-		appendStringInfo(buf, "xmax: %llu, off: %u, ",
-						 (unsigned long long) xlrec->xmax, xlrec->offnum);
+		appendStringInfo(buf, "xmax: %" PRIu64 ", off: %u, ",
+						 xlrec->xmax, xlrec->offnum);
 		infobits_desc(buf, xlrec->infobits_set, "infobits");
 		appendStringInfo(buf, ", flags: 0x%02X", xlrec->flags);
 	}
@@ -402,9 +396,9 @@ heap3_desc(StringInfo buf, XLogReaderState *record)
 	{
 		xl_heap_base_shift *xlrec = (xl_heap_base_shift *) rec;
 
-		appendStringInfo(buf, "%s delta %lld ",
+		appendStringInfo(buf, "%s delta %" PRIu64 " ",
 						 xlrec->multi ? "MultiXactId" : "XactId",
-						 (long long) xlrec->delta);
+						 xlrec->delta);
 	}
 }
 
diff --git a/src/backend/access/rmgrdesc/mxactdesc.c b/src/backend/access/rmgrdesc/mxactdesc.c
index 384de96c83..f1f561c298 100644
--- a/src/backend/access/rmgrdesc/mxactdesc.c
+++ b/src/backend/access/rmgrdesc/mxactdesc.c
@@ -19,7 +19,7 @@
 static void
 out_member(StringInfo buf, MultiXactMember *member)
 {
-	appendStringInfo(buf, "%llu ", (unsigned long long) member->xid);
+	appendStringInfo(buf, "%" PRIu64 " ", member->xid);
 	switch (member->status)
 	{
 		case MultiXactStatusForKeyShare:
@@ -65,9 +65,8 @@ multixact_desc(StringInfo buf, XLogReaderState *record)
 		xl_multixact_create *xlrec = (xl_multixact_create *) rec;
 		int			i;
 
-		appendStringInfo(buf, "%llu offset %llu nmembers %d: ",
-						 (unsigned long long) xlrec->mid,
-						 (unsigned long long) xlrec->moff, xlrec->nmembers);
+		appendStringInfo(buf, "%" PRIu64 " offset %" PRIu64 " nmembers %d: ",
+						 xlrec->mid, xlrec->moff, xlrec->nmembers);
 		for (i = 0; i < xlrec->nmembers; i++)
 			out_member(buf, &xlrec->members[i]);
 	}
@@ -75,11 +74,9 @@ multixact_desc(StringInfo buf, XLogReaderState *record)
 	{
 		xl_multixact_truncate *xlrec = (xl_multixact_truncate *) rec;
 
-		appendStringInfo(buf, "offsets [%llu, %llu), members [%llu, %llu)",
-						 (unsigned long long) xlrec->startTruncOff,
-						 (unsigned long long) xlrec->endTruncOff,
-						 (unsigned long long) xlrec->startTruncMemb,
-						 (unsigned long long) xlrec->endTruncMemb);
+		appendStringInfo(buf, "offsets [%" PRIu64 ", %" PRIu64 "), members [%" PRIu64 ", %" PRIu64 ")",
+						 xlrec->startTruncOff, xlrec->endTruncOff,
+						 xlrec->startTruncMemb, xlrec->endTruncMemb);
 	}
 }
 
diff --git a/src/backend/access/rmgrdesc/nbtdesc.c b/src/backend/access/rmgrdesc/nbtdesc.c
index b9d0ea28ad..8cd29c98e3 100644
--- a/src/backend/access/rmgrdesc/nbtdesc.c
+++ b/src/backend/access/rmgrdesc/nbtdesc.c
@@ -71,8 +71,8 @@ btree_desc(StringInfo buf, XLogReaderState *record)
 			{
 				xl_btree_delete *xlrec = (xl_btree_delete *) rec;
 
-				appendStringInfo(buf, "snapshotConflictHorizon: %llu, ndeleted: %u, nupdated: %u, isCatalogRel: %c",
-								 (unsigned long long) xlrec->snapshotConflictHorizon,
+				appendStringInfo(buf, "snapshotConflictHorizon: %" PRIu64 ", ndeleted: %u, nupdated: %u, isCatalogRel: %c",
+								 xlrec->snapshotConflictHorizon,
 								 xlrec->ndeleted, xlrec->nupdated,
 								 xlrec->isCatalogRel ? 'T' : 'F');
 
@@ -94,9 +94,9 @@ btree_desc(StringInfo buf, XLogReaderState *record)
 			{
 				xl_btree_unlink_page *xlrec = (xl_btree_unlink_page *) rec;
 
-				appendStringInfo(buf, "left: %u, right: %u, level: %u, safexid: %llu, ",
+				appendStringInfo(buf, "left: %u, right: %u, level: %u, safexid: %" PRIu64 ", ",
 								 xlrec->leftsib, xlrec->rightsib, xlrec->level,
-								 (unsigned long long) XidFromFullTransactionId(xlrec->safexid));
+								 XidFromFullTransactionId(xlrec->safexid));
 				appendStringInfo(buf, "leafleft: %u, leafright: %u, leaftopparent: %u",
 								 xlrec->leafleftsib, xlrec->leafrightsib,
 								 xlrec->leaftopparent);
@@ -113,10 +113,10 @@ btree_desc(StringInfo buf, XLogReaderState *record)
 			{
 				xl_btree_reuse_page *xlrec = (xl_btree_reuse_page *) rec;
 
-				appendStringInfo(buf, "rel: %u/%u/%u, snapshotConflictHorizon: %llu, isCatalogRel: %c",
+				appendStringInfo(buf, "rel: %u/%u/%u, snapshotConflictHorizon: %" PRIu64 ", isCatalogRel: %c",
 								 xlrec->locator.spcOid, xlrec->locator.dbOid,
 								 xlrec->locator.relNumber,
-								 (unsigned long long) XidFromFullTransactionId(xlrec->snapshotConflictHorizon),
+								 XidFromFullTransactionId(xlrec->snapshotConflictHorizon),
 								 xlrec->isCatalogRel ? 'T' : 'F');
 				break;
 			}
diff --git a/src/backend/access/rmgrdesc/spgdesc.c b/src/backend/access/rmgrdesc/spgdesc.c
index 7b4886fddb..de052aa203 100644
--- a/src/backend/access/rmgrdesc/spgdesc.c
+++ b/src/backend/access/rmgrdesc/spgdesc.c
@@ -118,10 +118,10 @@ spg_desc(StringInfo buf, XLogReaderState *record)
 			{
 				spgxlogVacuumRedirect *xlrec = (spgxlogVacuumRedirect *) rec;
 
-				appendStringInfo(buf, "ntoplaceholder: %u, firstplaceholder: %u, snapshotConflictHorizon: %llu, isCatalogRel: %c",
+				appendStringInfo(buf, "ntoplaceholder: %u, firstplaceholder: %u, snapshotConflictHorizon: %" PRIu64 ", isCatalogRel: %c",
 								 xlrec->nToPlaceholder,
 								 xlrec->firstPlaceholder,
-								 (unsigned long long) xlrec->snapshotConflictHorizon,
+								 xlrec->snapshotConflictHorizon,
 								 xlrec->isCatalogRel ? 'T' : 'F');
 			}
 			break;
diff --git a/src/backend/access/rmgrdesc/standbydesc.c b/src/backend/access/rmgrdesc/standbydesc.c
index 571c0f9092..a2911ca666 100644
--- a/src/backend/access/rmgrdesc/standbydesc.c
+++ b/src/backend/access/rmgrdesc/standbydesc.c
@@ -21,15 +21,15 @@ standby_desc_running_xacts(StringInfo buf, xl_running_xacts *xlrec)
 {
 	int			i;
 
-	appendStringInfo(buf, "nextXid %llu latestCompletedXid %llu oldestRunningXid %llu",
-					 (unsigned long long) xlrec->nextXid,
-					 (unsigned long long) xlrec->latestCompletedXid,
-					 (unsigned long long) xlrec->oldestRunningXid);
+	appendStringInfo(buf, "nextXid %" PRIu64 " latestCompletedXid %" PRIu64 " oldestRunningXid %" PRIu64,
+					 xlrec->nextXid,
+					 xlrec->latestCompletedXid,
+					 xlrec->oldestRunningXid);
 	if (xlrec->xcnt > 0)
 	{
 		appendStringInfo(buf, "; %d xacts:", xlrec->xcnt);
 		for (i = 0; i < xlrec->xcnt; i++)
-			appendStringInfo(buf, " %llu", (unsigned long long) xlrec->xids[i]);
+			appendStringInfo(buf, " %" PRIu64, xlrec->xids[i]);
 	}
 
 	if (xlrec->subxid_overflow)
@@ -39,8 +39,7 @@ standby_desc_running_xacts(StringInfo buf, xl_running_xacts *xlrec)
 	{
 		appendStringInfo(buf, "; %d subxacts:", xlrec->subxcnt);
 		for (i = 0; i < xlrec->subxcnt; i++)
-			appendStringInfo(buf, " %llu",
-							 (unsigned long long) xlrec->xids[xlrec->xcnt + i]);
+			appendStringInfo(buf, " %" PRIu64, xlrec->xids[xlrec->xcnt + i]);
 	}
 }
 
@@ -56,8 +55,8 @@ standby_desc(StringInfo buf, XLogReaderState *record)
 		int			i;
 
 		for (i = 0; i < xlrec->nlocks; i++)
-			appendStringInfo(buf, "xid %llu db %u rel %u ",
-							 (unsigned long long) xlrec->locks[i].xid,
+			appendStringInfo(buf, "xid %" PRIu64 " db %u rel %u ",
+							 xlrec->locks[i].xid,
 							 xlrec->locks[i].dbOid,
 							 xlrec->locks[i].relOid);
 	}
diff --git a/src/backend/access/rmgrdesc/xactdesc.c b/src/backend/access/rmgrdesc/xactdesc.c
index c2c5c30575..1e4ee011b2 100644
--- a/src/backend/access/rmgrdesc/xactdesc.c
+++ b/src/backend/access/rmgrdesc/xactdesc.c
@@ -306,7 +306,7 @@ xact_desc_subxacts(StringInfo buf, int nsubxacts, TransactionId *subxacts)
 	{
 		appendStringInfoString(buf, "; subxacts:");
 		for (i = 0; i < nsubxacts; i++)
-			appendStringInfo(buf, " %llu", (unsigned long long) subxacts[i]);
+			appendStringInfo(buf, " %" PRIu64, subxacts[i]);
 	}
 }
 
@@ -341,7 +341,7 @@ xact_desc_commit(StringInfo buf, uint8 info, xl_xact_commit *xlrec, RepOriginId
 
 	/* If this is a prepared xact, show the xid of the original xact */
 	if (TransactionIdIsValid(parsed.twophase_xid))
-		appendStringInfo(buf, "%llu: ", (unsigned long long) parsed.twophase_xid);
+		appendStringInfo(buf, "%" PRIu64 ": ", parsed.twophase_xid);
 
 	appendStringInfoString(buf, timestamptz_to_str(xlrec->xact_time));
 
@@ -377,7 +377,7 @@ xact_desc_abort(StringInfo buf, uint8 info, xl_xact_abort *xlrec, RepOriginId or
 
 	/* If this is a prepared xact, show the xid of the original xact */
 	if (TransactionIdIsValid(parsed.twophase_xid))
-		appendStringInfo(buf, "%llu: ", (unsigned long long) parsed.twophase_xid);
+		appendStringInfo(buf, "%" PRIu64 ": ", parsed.twophase_xid);
 
 	appendStringInfoString(buf, timestamptz_to_str(xlrec->xact_time));
 
@@ -434,7 +434,7 @@ xact_desc_assignment(StringInfo buf, xl_xact_assignment *xlrec)
 	appendStringInfoString(buf, "subxacts:");
 
 	for (i = 0; i < xlrec->nsubxacts; i++)
-		appendStringInfo(buf, " %llu", (unsigned long long) xlrec->xsub[i]);
+		appendStringInfo(buf, " %" PRIu64, xlrec->xsub[i]);
 }
 
 void
@@ -473,7 +473,7 @@ xact_desc(StringInfo buf, XLogReaderState *record)
 		 * interested in the top-level xid that issued the record and which
 		 * xids are being reported here.
 		 */
-		appendStringInfo(buf, "xtop %llu: ", (unsigned long long) xlrec->xtop);
+		appendStringInfo(buf, "xtop %" PRIu64 ": ", xlrec->xtop);
 		xact_desc_assignment(buf, xlrec);
 	}
 	else if (info == XLOG_XACT_INVALIDATIONS)
diff --git a/src/backend/access/rmgrdesc/xlogdesc.c b/src/backend/access/rmgrdesc/xlogdesc.c
index 3ac385ed6b..64f32dc5aa 100644
--- a/src/backend/access/rmgrdesc/xlogdesc.c
+++ b/src/backend/access/rmgrdesc/xlogdesc.c
@@ -66,26 +66,26 @@ xlog_desc(StringInfo buf, XLogReaderState *record)
 		CheckPoint *checkpoint = (CheckPoint *) rec;
 
 		appendStringInfo(buf, "redo %X/%X; "
-						 "tli %u; prev tli %u; fpw %s; wal_level %s; xid %llu; oid %u; multi %llu; offset %llu; "
-						 "oldest xid %llu in DB %u; oldest multi %llu in DB %u; "
-						 "oldest/newest commit timestamp xid: %llu/%llu; "
-						 "oldest running xid %llu; %s",
+						 "tli %u; prev tli %u; fpw %s; wal_level %s; xid %" PRIu64 "; oid %u; multi %" PRIu64 "; offset %" PRIu64 "; "
+						 "oldest xid %" PRIu64 " in DB %u; oldest multi %" PRIu64 " in DB %u; "
+						 "oldest/newest commit timestamp xid: %" PRIu64 "/%" PRIu64 "; "
+						 "oldest running xid %" PRIu64 "; %s",
 						 LSN_FORMAT_ARGS(checkpoint->redo),
 						 checkpoint->ThisTimeLineID,
 						 checkpoint->PrevTimeLineID,
 						 checkpoint->fullPageWrites ? "true" : "false",
 						 get_wal_level_string(checkpoint->wal_level),
-						 (unsigned long long) XidFromFullTransactionId(checkpoint->nextXid),
+						 XidFromFullTransactionId(checkpoint->nextXid),
 						 checkpoint->nextOid,
-						 (unsigned long long) checkpoint->nextMulti,
-						 (unsigned long long) checkpoint->nextMultiOffset,
-						 (unsigned long long) checkpoint->oldestXid,
+						 checkpoint->nextMulti,
+						 checkpoint->nextMultiOffset,
+						 checkpoint->oldestXid,
 						 checkpoint->oldestXidDB,
-						 (unsigned long long) checkpoint->oldestMulti,
+						 checkpoint->oldestMulti,
 						 checkpoint->oldestMultiDB,
-						 (unsigned long long) checkpoint->oldestCommitTsXid,
-						 (unsigned long long) checkpoint->newestCommitTsXid,
-						 (unsigned long long) checkpoint->oldestActiveXid,
+						 checkpoint->oldestCommitTsXid,
+						 checkpoint->newestCommitTsXid,
+						 checkpoint->oldestActiveXid,
 						 (info == XLOG_CHECKPOINT_SHUTDOWN) ? "shutdown" : "online");
 	}
 	else if (info == XLOG_NEXTOID)
diff --git a/src/backend/access/transam/commit_ts.c b/src/backend/access/transam/commit_ts.c
index 7c36b8cbd0..c7af67ffb3 100644
--- a/src/backend/access/transam/commit_ts.c
+++ b/src/backend/access/transam/commit_ts.c
@@ -284,8 +284,8 @@ TransactionIdGetCommitTsData(TransactionId xid, TimestampTz *ts,
 	if (!TransactionIdIsValid(xid))
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
-				 errmsg("cannot retrieve commit timestamp for transaction %llu",
-						(unsigned long long) xid)));
+				 errmsg("cannot retrieve commit timestamp for transaction %" PRIu64,
+						xid)));
 	else if (!TransactionIdIsNormal(xid))
 	{
 		/* frozen and bootstrap xids are always committed far in the past */
